<template src="./template.html"/>
<style scoped lang="scss" src="./style.scss" />

<script>
import axios from 'axios';
import {store} from "../../../../store/store";

    export default {
        name: "ShopList",
        data() {
            return {
                searchText: '',
                shops: null,
                ownerEmailData: {
                    id: null,
                    shopName: '',
                    email: '',
                    valid: false
                },

                fields: [
                    {
                        key: 'name',
                        label: 'Nome'
                    },
                    {
                        key: 'description',
                        label: 'Descrizione'
                    },
                    {
                        key: 'ownerEmail',
                        label: 'Email di accesso'
                    },
                    {
                        key: 'edit',
                        label: ''
                    },
                    {
                        key: 'delete',
                        label: ''
                    }
                ]
            }
        },
        mounted() {
            this.loadShops();
        },
        computed: {
            filtered() {
                return !this.searchText ? this.shops :
                    this.shops.filter(s =>
                        s.name?.includes(this.searchText) ||
                        s.description?.includes(this.searchText) ||
                        s.ownerEmail?.includes(this.searchText)
                    );
            },
            ownerEmailValid() {
                return !!this.ownerEmailData.email;
            }
        },
        methods: {
            loadShops() {
                axios({
                    method: "GET",
                    url: '/Store/admin',
                    headers: {
                        Authorization: 'Bearer ' + store.getters.token
                    }
                }).then(response => {
                    this.shops = response.data;
                }).catch(this.showResponseModalError);
            },
            showResponseModalError(error) {
                this.$bvModal.msgBoxOk(error.response.data.error, {
                    title: 'Attenzione',
                    okVariant: 'primary',
                    headerTextVariant: 'warning'
                });
            },

            editShop(id) {
                this.$router.push('/dashboard/modifica-negozio/' + id);
            },
            deleteShop(id, shopName) {
                this.$bvModal.msgBoxConfirm(
                    'Sei sicuro di voler eliminare definitivamente questo negozio "' + shopName + '"?')
                .then(value => {
                    if(value) {
                        axios({
                            method: 'DELETE',
                            url: 'store/admin/' + id,
                            headers: {
                                Authorization: 'Bearer ' + store.getters.token
                            }
                        }).then(() => {
                            this.loadShops();
                        }).catch(this.showResponseModalError);
                    }
                });
            },
            openOwnerEmailModal(id, shopName) {
                if(!id) return;
                this.ownerEmailData.id = id;
                this.ownerEmailData.shopName = shopName;
                this.$bvModal.show('addOwnerEmailModal');
            },

            addOwnerEmail() {
                if(!this.ownerEmailData.email || !this.ownerEmailData.id) return;

                axios({
                    method: 'POST',
                    url: 'store/admin/addowner/' + this.ownerEmailData.id,
                    headers: {
                        Authorization: 'Bearer ' + store.getters.token
                    },
                    data: {
                        email: this.ownerEmailData.email
                    }
                }).then(() => {
                    this.loadShops();
                    this.$bvModal.hide('addOwnerEmailModal');
                }).catch(this.showResponseModalError);
            }
        }
    }
</script>
